﻿using System.ComponentModel;
using DHI.Solutions.Generic.Business;
using MyNoteManager.Interfaces;

namespace MyNoteManager.Business
{
    public class MyNoteGroup : BaseGroup, IMyNoteGroup
    {

        #region constructor

        /// <summary>
        /// Initializes a new instance of the MyNoteGroup class.
        /// </summary>
        protected internal MyNoteGroup()
        {
        }

        #endregion

        #region relationship to parent

        /// <summary>
        /// Gets or sets group parent.
        /// </summary>
        /// <remarks>
        /// Don't use this property for accessing Parent data. 
        /// Only Parent.Id property is guaranteed to be set correctly.
        /// </remarks>
        [Browsable(false)]
        protected internal virtual MyNoteGroup Parent
        {
            get
            {
                if (ParentId == null)
                {
                    return null;
                }
                else
                {
                    return new MyNoteGroup() { Id = ParentId };
                }
            }

            set
            {
                if (value == null)
                {
                    ParentId = null;
                }
                else
                {
                    ParentId = value.Id;
                }
            }
        }

        #endregion

        #region IClonable

        /// <inheritdoc />
        public virtual object Clone()
        {
            return this.MemberwiseClone();
        }

        #endregion
    }
}