﻿using System.Collections.Generic;
using DHI.Solutions.Generic;
using DHI.Solutions.Generic.Business;
using MyNoteManager.Data;
using MyNoteManager.Interfaces;

namespace MyNoteManager.Business
{
    public class MyNoteGroupList : BaseGroupEntityList<IMyNoteGroup>, IMyNoteGroupList
    {
        private MyNoteModule _module;
        private MyNoteGroupDAO _dao;

        internal MyNoteGroupList(IApplication app, MyNoteModule module)
            : base(app)
        {
            _module = module;
            _dao = new MyNoteGroupDAO();
        }

        protected override string EntityName
        {
            get { return Resources.MyNoteGroupList_EntityName; }
        }

        protected override IMyNoteGroup _CreateNew()
        {
            return new MyNoteGroup();
        }

        protected override IDAOReader<IMyNoteGroup> _DAOReader
        {
            get { return _dao; }
        }

        protected override IDAOWriter<IMyNoteGroup> _DAOWriter
        {
            get { return _dao; }
        }

        protected override void _DeleteEntities(IMyNoteGroup group)
        {
            Query qEntities = new Query();
            qEntities.Add(new QueryElement("GroupId", group.Id, QueryOperator.Eq));
            IList<IMyNote> entities = _module.MyNoteList.Fetch(qEntities);
            _module.MyNoteList.Delete(entities);
        }
    }
}
