﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MyNoteManager.Interfaces;
using MyNoteManager.Data;
using DHI.Solutions.Generic;
using DHI.Solutions.Generic.Business;
using DHI.Solutions.Generic.Data;

namespace MyNoteManager.Business
{
    public class MyNoteList : BaseGroupedEntityList<IMyNote,IMyNoteGroup>, IMyNoteList
    {

        private IDAO<IMyNote> _myNoteDAO;
        private IMyNoteModule _module = null;

        internal MyNoteList(IApplication app)
            : base(app)
        {
            _app = app;
            _module = app.Modules.Get(typeof(IMyNoteModule)) as IMyNoteModule;
            _myNoteDAO = new MyNoteDAO();
        }
    
        /// <inheritdoc />
        protected override string EntityName
        {
            get { return Resources.MyNoteList_EntityName; }
        }

        /// <inheritdoc/>
        protected override IGroupedEntityList<IMyNoteGroup> _GroupList
        {
            get { return _module.MyNoteGroupList; }
        }

        /// <inheritdoc />
        protected override IMyNote _CreateNew()
        {
            return new MyNote();
        }

        /// <inheritdoc />
        protected override IDAOReader<IMyNote> _DAOReader
        {
            get { return _myNoteDAO; }
        }

        /// <inheritdoc />
        protected override IDAOWriter<IMyNote> _DAOWriter
        {
            get { return _myNoteDAO; }
        }

        /// <inheritdoc />
        protected override void _DeleteChildren(IMyNote entity)
        {
            // no children
        }

        /// <inheritdoc />
        protected override bool _ValidateEntity(IMyNote entity, bool newEntity, out string error)
        {
            return base._ValidateEntity(entity, newEntity, out error);
        }
        
        /// <inheritdoc />
        protected override bool ConcurrencyEnabled
        {
            get
            {
                return true;
            }
        }
    }
}
