﻿using System;
using System.ComponentModel;
using System.Windows.Forms;
using DHI.Solutions.Generic;
using DHI.Solutions.Generic.UI;

namespace MyNoteManager.UI
{
    [SupportedTypes(new Type[] { typeof(MyNoteDataView) })]
    public partial class MyNoteToolStrip : BaseToolStrip
    {
        private IShell _shell;
        private MyNoteDataView _dataView;

        public MyNoteToolStrip()
        {
            Name = "MyNoteToolStrip";
            Caption = Text;
            Control = this;
        }

        /// <inheritdoc />
        public override void Initialize(IShell shell)
        {
            _shell = shell;
            _dataView = GetEmbeddedControl<MyNoteDataView>();

            ToolStripButton tsSave = new SaveButton(this, _dataView);

            Items.Add(tsSave);
        }
    }
}
