\connect :databasename

SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET search_path = :schemaname, public, pg_catalog;

-- Table: :schemaname.note

-- DROP TABLE :schemaname.note;

CREATE TABLE mynote
(
  id uuid NOT NULL,
  "name" character varying(255) NOT NULL,
  text text NOT NULL,
  group_id uuid,
  "version" uuid NOT NULL DEFAULT '00000000-0000-0000-0000-000000000000'::uuid,
  CONSTRAINT mynote_pk PRIMARY KEY (id)
)
WITH (OIDS=FALSE);
ALTER TABLE mynote OWNER TO admin;

-- Table: :schemaname.mynote_group

-- DROP TABLE :schemaname.mynote_group;

CREATE TABLE mynote_group
(
  id uuid NOT NULL,
  "name" character varying(255) NOT NULL,
  parent_id uuid,
  "version" uuid NOT NULL DEFAULT '00000000-0000-0000-0000-000000000000'::uuid,
  CONSTRAINT mynote_group_pk PRIMARY KEY (id),
  CONSTRAINT mynote_group_parent_id_fk FOREIGN KEY (parent_id)
      REFERENCES mynote_group (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (OIDS=FALSE);
ALTER TABLE mynote_group OWNER TO admin;


-- give permissions to the 3 user groups
GRANT ALL ON TABLE mynote TO workspace_lead;
GRANT ALL ON TABLE mynote TO workspace_member;
GRANT SELECT ON TABLE mynote TO workspace_reviewer;

GRANT ALL ON TABLE mynote_group TO workspace_lead;
GRANT ALL ON TABLE mynote_group TO workspace_member;
GRANT SELECT ON TABLE mynote_group TO workspace_reviewer;	